// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
const APIM_SUBSCRIPTION_KEY_HEADER = "Ocp-Apim-Subscription-Key";
/**
 * Create an HTTP pipeline policy to authenticate a request using an `AzureKeyCredential` for Azure Form Recognizer
 * @internal
 */
export function createFormRecognizerAzureKeyCredentialPolicy(credential) {
    return {
        name: "cognitiveServicesApimSubscriptionKeyCredentialPolicy",
        sendRequest(request, next) {
            request.headers.set(APIM_SUBSCRIPTION_KEY_HEADER, credential.key);
            return next(request);
        },
    };
}
//# sourceMappingURL=azureKeyCredentialPolicy.js.map