// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
import { FormRecognizerError } from "../error";
/**
 * Convert an operation result into a training poller state.
 * @internal
 */
export async function toTrainingPollOperationState(response) {
    var _a;
    return {
        operationId: response.operationId,
        status: response.status,
        apiVersion: response.apiVersion,
        percentCompleted: (_a = response.percentCompleted) !== null && _a !== void 0 ? _a : 0,
        lastUpdatedOn: response.lastUpdatedOn,
        createdOn: response.createdOn,
        error: response.error && new FormRecognizerError(response.error),
        isCancelled: response.status === "canceled",
        isCompleted: response.status === "succeeded",
        isStarted: response.status !== "notStarted",
        tags: response.tags,
        result: response.result,
    };
}
//# sourceMappingURL=administration.js.map